<!-- // Code generated by coz. DO NOT EDIT. -->
# the-scope@3.1.0

State scope for the-store

+ Functions
  + [create(args)](#the-scope-function-create)
  + [set(index, entry)](#the-scope-function-set)
+ [`TheScope`](#the-scope-classes) Class
  + [new TheScope(name, config)](#the-scope-classes-the-scope-constructor)
+ [`ArrayScope`](#the-scope-classes) Class
  + [new ArrayScope()](#the-scope-classes-array-scope-constructor)
  + [scope.concat(values)](#the-scope-classes-array-scope-concat)
  + [scope.pop()](#the-scope-classes-array-scope-pop)
  + [scope.push(entry)](#the-scope-classes-array-scope-push)
  + [scope.reset(values)](#the-scope-classes-array-scope-reset)
  + [scope.shift()](#the-scope-classes-array-scope-shift)
  + [scope.unshift(entry)](#the-scope-classes-array-scope-unshift)
+ [`BooleanScope`](#the-scope-classes) Class
  + [new BooleanScope()](#the-scope-classes-boolean-scope-constructor)
  + [scope.toggle(value)](#the-scope-classes-boolean-scope-toggle)
  + [scope.false()](#the-scope-classes-boolean-scope-false)
  + [scope.set()](#the-scope-classes-boolean-scope-set)
  + [scope.true()](#the-scope-classes-boolean-scope-true)
+ [`NullScope`](#the-scope-classes) Class
  + [new NullScope()](#the-scope-classes-null-scope-constructor)
+ [`NumberScope`](#the-scope-classes) Class
  + [new NumberScope()](#the-scope-classes-number-scope-constructor)
  + [scope.decrement(amount)](#the-scope-classes-number-scope-decrement)
  + [scope.increment(amount)](#the-scope-classes-number-scope-increment)
  + [scope.set(n)](#the-scope-classes-number-scope-set)
  + [scope.isNegative()](#the-scope-classes-number-scope-isNegative)
  + [scope.isPositive()](#the-scope-classes-number-scope-isPositive)
  + [scope.isZero()](#the-scope-classes-number-scope-isZero)
+ [`ObjectScope`](#the-scope-classes) Class
  + [new ObjectScope()](#the-scope-classes-object-scope-constructor)
  + [scope.del(names)](#the-scope-classes-object-scope-del)
  + [scope.drop()](#the-scope-classes-object-scope-drop)
  + [scope.set(name, value)](#the-scope-classes-object-scope-set)
  + [scope.get()](#the-scope-classes-object-scope-get)
  + [scope.has()](#the-scope-classes-object-scope-has)
+ [`Scope`](#the-scope-classes) Class
  + [new Scope(name, config)](#the-scope-classes-scope-constructor)
  + [scope.withDefault()](#the-scope-classes-scope-withDefault)
+ [`ScopeScope`](#the-scope-classes) Class
  + [new ScopeScope()](#the-scope-classes-scope-scope-constructor)
  + [scope.get(namepath)](#the-scope-classes-scope-scope-get)
  + [scope.has(namepath)](#the-scope-classes-scope-scope-has)
  + [scope.init(names)](#the-scope-classes-scope-scope-init)
  + [scope.of(namepath)](#the-scope-classes-scope-scope-of)
  + [scope.set(namepath, value)](#the-scope-classes-scope-scope-set)
+ [`StringScope`](#the-scope-classes) Class
  + [new StringScope()](#the-scope-classes-string-scope-constructor)
  + [scope.del()](#the-scope-classes-string-scope-del)
  + [scope.replace(from, to)](#the-scope-classes-string-scope-replace)
  + [scope.set(value)](#the-scope-classes-string-scope-set)
+ [`ValueScope`](#the-scope-classes) Class
  + [new ValueScope()](#the-scope-classes-value-scope-constructor)
  + [scope.del()](#the-scope-classes-value-scope-del)
  + [scope.set(value)](#the-scope-classes-value-scope-set)

## Functions

<a class='md-heading-link' name="the-scope-function-create" ></a>

### create(args) -> `TheScope`

Create a TheScope instance

| Param | Type | Description |
| ----- | --- | -------- |
| args | * |  |

<a class='md-heading-link' name="the-scope-function-set" ></a>

### set(index, entry)

Set entry at index

| Param | Type | Description |
| ----- | --- | -------- |
| index | number |  |
| entry | * |  |



<a class='md-heading-link' name="the-scope-classes"></a>

## `TheScope` Class

Abstract state class




<a class='md-heading-link' name="the-scope-classes-the-scope-constructor" ></a>

### new TheScope(name, config)

Constructor of TheScope class

| Param | Type | Description |
| ----- | --- | -------- |
| name | string | Name of state |
| config | Object | TheScope config |


<a class='md-heading-link' name="the-scope-classes"></a>

## `ArrayScope` Class

Scope to hold array

**Extends**: 

+ `Scope`



<a class='md-heading-link' name="the-scope-classes-array-scope-constructor" ></a>

### new ArrayScope()

Constructor of ArrayScope class



<a class='md-heading-link' name="the-scope-classes-array-scope-concat" ></a>

### scope.concat(values)

Concat values

| Param | Type | Description |
| ----- | --- | -------- |
| values | * |  |


<a class='md-heading-link' name="the-scope-classes-array-scope-pop" ></a>

### scope.pop()

Pop entry

<a class='md-heading-link' name="the-scope-classes-array-scope-push" ></a>

### scope.push(entry)

Push entry

| Param | Type | Description |
| ----- | --- | -------- |
| entry | * |  |


<a class='md-heading-link' name="the-scope-classes-array-scope-reset" ></a>

### scope.reset(values)

Reset state with values

| Param | Type | Description |
| ----- | --- | -------- |
| values | Array |  |


<a class='md-heading-link' name="the-scope-classes-array-scope-shift" ></a>

### scope.shift()

Shift entry

<a class='md-heading-link' name="the-scope-classes-array-scope-unshift" ></a>

### scope.unshift(entry)

Unshift entry

| Param | Type | Description |
| ----- | --- | -------- |
| entry | * |  |


<a class='md-heading-link' name="the-scope-classes"></a>

## `BooleanScope` Class

Scope to hold boolean

**Extends**: 

+ `Scope`



<a class='md-heading-link' name="the-scope-classes-boolean-scope-constructor" ></a>

### new BooleanScope()

Constructor of BooleanScope class



<a class='md-heading-link' name="the-scope-classes-boolean-scope-toggle" ></a>

### scope.toggle(value)

Toggle value

| Param | Type | Description |
| ----- | --- | -------- |
| value | Boolean |  |


<a class='md-heading-link' name="the-scope-classes-boolean-scope-false" ></a>

### scope.false()

Toggle to false

<a class='md-heading-link' name="the-scope-classes-boolean-scope-set" ></a>

### scope.set()

Alias of toggle

<a class='md-heading-link' name="the-scope-classes-boolean-scope-true" ></a>

### scope.true()

Toggle to true

<a class='md-heading-link' name="the-scope-classes"></a>

## `NullScope` Class

Scope to hold null

**Extends**: 

+ `Scope`



<a class='md-heading-link' name="the-scope-classes-null-scope-constructor" ></a>

### new NullScope()

Constructor of NullScope class



<a class='md-heading-link' name="the-scope-classes"></a>

## `NumberScope` Class

Scope to hold number

**Extends**: 

+ `Scope`



<a class='md-heading-link' name="the-scope-classes-number-scope-constructor" ></a>

### new NumberScope()

Constructor of NumberScope class



<a class='md-heading-link' name="the-scope-classes-number-scope-decrement" ></a>

### scope.decrement(amount)

Decrement value

| Param | Type | Description |
| ----- | --- | -------- |
| amount | number |  |


<a class='md-heading-link' name="the-scope-classes-number-scope-increment" ></a>

### scope.increment(amount)

Increment value

| Param | Type | Description |
| ----- | --- | -------- |
| amount | number |  |


<a class='md-heading-link' name="the-scope-classes-number-scope-set" ></a>

### scope.set(n)

Set number

| Param | Type | Description |
| ----- | --- | -------- |
| n | number |  |


<a class='md-heading-link' name="the-scope-classes-number-scope-isNegative" ></a>

### scope.isNegative() -> `boolean`

Check the value is negative

<a class='md-heading-link' name="the-scope-classes-number-scope-isPositive" ></a>

### scope.isPositive() -> `boolean`

Check the value is positive

<a class='md-heading-link' name="the-scope-classes-number-scope-isZero" ></a>

### scope.isZero() -> `boolean`

Check the value is zero

<a class='md-heading-link' name="the-scope-classes"></a>

## `ObjectScope` Class

Scope to hold object

**Extends**: 

+ `Scope`



<a class='md-heading-link' name="the-scope-classes-object-scope-constructor" ></a>

### new ObjectScope()

Constructor of ObjectScope class



<a class='md-heading-link' name="the-scope-classes-object-scope-del" ></a>

### scope.del(names)

Delete property

| Param | Type | Description |
| ----- | --- | -------- |
| names | string | Name to delete |


<a class='md-heading-link' name="the-scope-classes-object-scope-drop" ></a>

### scope.drop()

Delete all

<a class='md-heading-link' name="the-scope-classes-object-scope-set" ></a>

### scope.set(name, value)

Set property

| Param | Type | Description |
| ----- | --- | -------- |
| name | string | name to set |
| value | * | Value to set |


<a class='md-heading-link' name="the-scope-classes-object-scope-get" ></a>

### scope.get()

Get a value for name

<a class='md-heading-link' name="the-scope-classes-object-scope-has" ></a>

### scope.has()

Check value exists for name

<a class='md-heading-link' name="the-scope-classes"></a>

## `Scope` Class

Abstract scope class




<a class='md-heading-link' name="the-scope-classes-scope-constructor" ></a>

### new Scope(name, config)

Constructor of Scope class

| Param | Type | Description |
| ----- | --- | -------- |
| name | string | Name of state |
| config | Object | Scope config |


<a class='md-heading-link' name="the-scope-classes-scope-withDefault" ></a>

### scope.withDefault()



<a class='md-heading-link' name="the-scope-classes"></a>

## `ScopeScope` Class

Scope to other scopes

**Extends**: 

+ `Scope`



<a class='md-heading-link' name="the-scope-classes-scope-scope-constructor" ></a>

### new ScopeScope()

Constructor of ScopeScope class



<a class='md-heading-link' name="the-scope-classes-scope-scope-get" ></a>

### scope.get(namepath) -> `*`

Get state value from name path string

| Param | Type | Description |
| ----- | --- | -------- |
| namepath | string |  |


<a class='md-heading-link' name="the-scope-classes-scope-scope-has" ></a>

### scope.has(namepath) -> `boolean`

Check if scope exists

| Param | Type | Description |
| ----- | --- | -------- |
| namepath | string |  |


<a class='md-heading-link' name="the-scope-classes-scope-scope-init" ></a>

### scope.init(names)

Init scope values

| Param | Type | Description |
| ----- | --- | -------- |
| names |  |  |


<a class='md-heading-link' name="the-scope-classes-scope-scope-of" ></a>

### scope.of(namepath) -> `ScopeScope`

Sub scope of namepath

| Param | Type | Description |
| ----- | --- | -------- |
| namepath |  |  |


<a class='md-heading-link' name="the-scope-classes-scope-scope-set" ></a>

### scope.set(namepath, value)

Set state with name path

| Param | Type | Description |
| ----- | --- | -------- |
| namepath | string |  |
| value | * |  |


<a class='md-heading-link' name="the-scope-classes"></a>

## `StringScope` Class

Scope to hold value

**Extends**: 

+ `Scope`



<a class='md-heading-link' name="the-scope-classes-string-scope-constructor" ></a>

### new StringScope()

Constructor of StringScope class



<a class='md-heading-link' name="the-scope-classes-string-scope-del" ></a>

### scope.del()

Delete property

<a class='md-heading-link' name="the-scope-classes-string-scope-replace" ></a>

### scope.replace(from, to)

Replace string

| Param | Type | Description |
| ----- | --- | -------- |
| from | string,RegExp |  |
| to | string |  |


<a class='md-heading-link' name="the-scope-classes-string-scope-set" ></a>

### scope.set(value)

Set property

| Param | Type | Description |
| ----- | --- | -------- |
| value | * | Value to set |


<a class='md-heading-link' name="the-scope-classes"></a>

## `ValueScope` Class

Scope to hold value

**Extends**: 

+ `Scope`



<a class='md-heading-link' name="the-scope-classes-value-scope-constructor" ></a>

### new ValueScope()

Constructor of ValueScope class



<a class='md-heading-link' name="the-scope-classes-value-scope-del" ></a>

### scope.del()

Delete property

<a class='md-heading-link' name="the-scope-classes-value-scope-set" ></a>

### scope.set(value)

Set property

| Param | Type | Description |
| ----- | --- | -------- |
| value | * | Value to set |




